
const json2md = require("json2md")
const writeFile = require('write');
const readTextFile = require('read-text-file');
const fetch = require('node-fetch');
const htmlParser = require('html-parser');

//here sync with the gist Json
fetch('https://gist.github.com/Rober19/50c6c03ec4f3fd222a58a1765ada8c15.json')
    .then(async res => await res.json())
    .then(async body => {
        const html = await body.div;
        htmlParser.parse(html, {
            attribute: function (name, value) {
                if (name == 'href') {
                    let a1 = (String(value).endsWith('resMsg.json')) ? value : undefined
                    if (a1) fetch(a1)
                        .then(async res => await res.json())
                        .then(async body => {
                            writeFile.sync('resMsgSource.json', JSON.stringify(body), null, "\t")
                        })

                }
            },
        });



    });

const msgJson = JSON.stringify(require('./resMsgSource.json'), null, "\t")
//const msgJson2 = JSON.parse(JSON.stringify(require('./resMsgSource.json')));

//this is the auto-readme writing
writeFile.sync('README.md', json2md([
    { h1: "rober19-config" }
    , { blockquote: "rober19-config" },
    { p: '[![NPM](https://img.shields.io/badge/js-on-yellow.svg)](https://www.npmjs.com/package/rober19-config) [![NPM](https://img.shields.io/badge/npm-v1-brightgreen.svg)](https://www.npmjs.com/package/rober19-config) [![NPM](https://img.shields.io/badge/ts-on-blue.svg)](https://www.npmjs.com/package/rober19-config)' }
    , { p: '## Install' }
    , { p: '$ npm install rober19-config' }
    , { p: '## Usage' }
    , { p: 'Javascript' }
    , {
        "code": {
            language: "js"
            , content: [
                'const { resMsg } = require(\'rober19-config/config-js\');'
                , ''
                , 'console.log(resMsg.confirm); //=> \'Confirmado\''
            ]
        }
    }
    , { p: 'Typescript' }
    , {
        "code": {
            language: "ts"
            , content: [
                'import { resMsg } from \'rober19-config\'',
                , ''
                , 'console.log(resMsg.confirm) //=> Confirmado'

            ]
        }
    }
    , { p: '### resMsg' }
    , {
        "code": {
            language: "json"
            , content: [msgJson
            ]
        }
    }
]));

//writeFile.sync('foo.md', '')

let config_js = readTextFile.readSync('template.js');
config_js += `
exports.resMsg = ${msgJson}
`
writeFile.sync('config-js.js', config_js)


let index_js = readTextFile.readSync('./dist/template_index.js');
index_js += `
exports.resMsg = ${msgJson}
`
writeFile.sync('./dist/index.js', index_js)

let config_ts = readTextFile.readSync('template.ts');
config_ts += `
export const resMsg = ${msgJson}
`
writeFile.sync('config-ts.ts', config_ts)